unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

const
  {Konstanty dulezite na prevody kodovani}
  PocetPismen = 30;    {pocet pismenek v jedne tabulce}
  PocetTabulek = 5;    {(#) celkovy pocet tabulek a tedy i kodovani cestin}
  BufLen = 32767;
type
  {Typy na prevody kodovani}
  TTabulka = string [PocetPismen];
  TTables  = array [1..PocetTabulek] of TTabulka;
  TCzech   = (None, Kam, Lat, cp1250, Koi8);  {(#)Jednotlive typy kodovani}
  TBuffer  = array [1..BufLen] of Byte;

  TMainForm = class(TForm)
    Panel1: TPanel;
    FromRG: TRadioGroup;
    ToRG: TRadioGroup;
    Label1: TLabel;
    OKButton: TBitBtn;
    CancelButton: TBitBtn;
    OpenFileDialog: TOpenDialog;
    BackupCheckBox: TCheckBox;
    Bevel1: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);

    procedure InitTables;
    function  PrevedZnak (FromCs, ToCs: Byte; Z: Char): Char;
    procedure Preved (FromCS, ToCS: Byte; var What: PChar);
    procedure PrevodSouboru (FromCs, ToCs: Byte; FileName: string;
                             Backup: Boolean);
    procedure OKButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Tables: TTables;
  end;

{############################################################################}
{####  Jednotlive tabulky obsahujici pismenka, ktera se lisi v kodovani  ####}
{############################################################################}
const
  NotCs :  TTabulka =  'aAcCdDeEeEiInNoOrRsStTuUuUyYzZ';
  KamCs : TTabulka =   '';
  LatCs :  TTabulka =  '҂طբ望';
  cp1250Cs: TTabulka = 'ؚݞ';
  Koi8Cs:  TTabulka =  '';


  {(#) --- Pridat dalsi tabulku}

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

{...............................................................FormCreate...}
procedure TMainForm.FormCreate(Sender: TObject);
var
  FileName: string;
begin
  FileName := '';
  if (ParamCount < 1) then begin
    if (not OpenFileDialog.Execute) then Halt
    else FileName := OpenFileDialog.FileName;
  end;

  if (FileName = '') then FileName := (ParamStr (1));

  if (not FileExists (FileName)) then begin
    MessageDlg ('Takovej soubor tady vbec nen!', mtError, [mbOK], 0);
    Halt;
  end;

  MainForm.Caption := 'Ach ten etin (' + ExtractFileName (FileName) + ')';
  InitTables;
end;

{........................................................CancelButtonClick...}
procedure TMainForm.CancelButtonClick(Sender: TObject);
begin
  Close;
end;

{---------------------------------------------------------------InitTables---}
{Pred vlastnim prevodem se musi zavolat tato procedura!!!!!!!!!!!!!!!!!!!!!!!
 Vytvori tabulku tabulek jednotlivych kodovani }
procedure TMainForm.InitTables;
begin {InitTables}
{Achtung - poradi, ktere je uvedeno nize je dulezite! musi odpovidat
 poradi v typu TCzech!!}
  Tables [1] := NotCs;
  Tables [2] := KamCs;
  Tables [3] := LatCs;
  Tables [4] := cp1250Cs;
  Tables [5] := Koi8Cs;
  {(#)}
end; {InitTables}

{---------------------------------------------------------------PrevedZnak---}
{Funkce ktera prevede JEDEN ZNAK z kodovani FromCS do kodovani ToCs}
function TMainForm.PrevedZnak (FromCs, ToCs: Byte; Z: Char): Char;
var
  Ok: Boolean;
  i: Byte;
begin {PrevedZnak}
  PrevedZnak := Z;

{mala rybka....necha ji jit  :-)  }
  if Z < #128 then Exit;

  OK := False;
  i := 0;
  repeat
{prohledava vstupni tabulku a hleda v ni dany znak Z
   * pokud jej najde, koukne se do vystupni tabulky a z teto vezme
     ekvivalentni znak
   * pokud jej nenajde, znamena to, ze na nem nezalezi a tedy jej ponecha
     nezmenen}
    Inc (i);
    if Z = Tables [FromCs,i] then
      begin {Nasel ho}
        OK := True;
        PrevedZnak := Tables [ToCs,i];
      end; {Nasel ho}
  until OK or (i=PocetPismen);
  {Pokud jej nenasel, tak ho nechal bejt}
end; {PrevedZnak}

{-------------------------------------------------------------------Preved---}
{ Prevede STRING  What z kodovani FromCS do kodovani ToCS }
procedure TMainForm.Preved (FromCS, ToCS: Byte; var What: PChar);
var
  i: integer;
begin {Preved}
  for i := 0 to StrLen (What) do
    What[i] := PrevedZnak (FromCS, ToCS, What[i]);
end; {Preved}

{------------------------------------------------------------PrevodSouboru---}
procedure TMainForm.PrevodSouboru (FromCs, ToCs: Byte; FileName: string;
                                   Backup: Boolean);
var
  i, Max: Integer;
  F: File;
  Buffer: TBuffer;
  Pos: LongInt;
  BackFileName: string;
begin

  if (Backup) then begin
    BackFileName := FileName;
    repeat
      BackFileName := BackFileName + '~';
    until (CopyFile (PChar (FileName), PChar (BackFileName), TRUE));
  end;

  System.Assign (F, FileName);
  Reset (F, 1);
  Pos := 0;

  while not Eof (F) do begin
    Max := BufLen;
    BlockRead (F, Buffer, BufLen, Max);
    {Vlastni prevedeni cestiny}
    for i := 1 to Max do
      Buffer[i] := Ord (PrevedZnak (FromCs, ToCs, Chr (Buffer[i])));
    Seek (F, Pos);
    Pos := Pos + Max;
    BlockWrite (F, Buffer, Max);
  end;

end;

{............................................................OKButtonClick...}
procedure TMainForm.OKButtonClick(Sender: TObject);
var
  i: Integer;
  FileName: string;
begin
  if (ParamCount > 0) then begin
    PrevodSouboru (FromRG.ItemIndex+2, ToRG.ItemIndex+1,ParamStr (1),
                   BackupCheckBox.Checked);
    Close;
  end
  else begin
    for i := 0 to OpenFileDialog.Files.Count-1 do begin
      FileName := OpenFileDialog.Files [i];
      if (not FileExists (FileName)) then
         MessageDlg ('Takovej soubor tady nen!' + Chr(13) +
                     '(' + FileName + ')', mtError, [mbOK], 0)
      else begin
        MainForm.Caption := 'Ach ten etin (' + ExtractFileName (FileName) +
                            ')';
        PrevodSouboru (FromRG.ItemIndex+2, ToRG.ItemIndex+1, FileName,
                       BackupCheckBox.Checked);
      end; {OK}
    end; {for}
    Close;
  end; {MultiFile}
end; {Procedure}

end.
